const ModbusRTU = require('modbus-serial')


let client
// 寄存器循环
let time = null

// 连接modbus
export function link(event, message) {
    // 创建modbus连接
    client = new ModbusRTU()
    // 根据IP连接modbus
    client.connectTCP(message.ip, { port: 502 }, function (err) {
        if (err) {
            console.log('连接失败', err)
            event.reply('linkReply', { code: 4, message: '连接失败', err })
            return
        }
        console.log('连接成功')
        event.reply('linkReply', { code: 200, message: '连接成功' })
    }
    )
    read(event, message)
}

// 根据页面需要的数据读取寄存器（定义一个读取寄存器并返回数据到渲染进程的方法）
function readClient(event, message) {
    // 连接成功后定义读取寄存器方法
    client.readHoldingRegisters(message.startAddress, message.quantity, function (err, data) {
        if (err) {
            event.reply('readReply', err)
            return
        }
        // realTimeData[0].push(data.data[0])
        //console.log('data',data.data)
        event.reply('readReply', data.data)
    })
}

// 调用根据页面需要的数据读取寄存器的方法
export function read(event, message) {
    if (!(time == null)) {
        console.log('重复读取数据', time)
        return
    }
    // 循环读取寄存器
    time = setInterval(() => {
        readClient(event, message)
    }, 1000)
}

export function stopRead(event) {

    clearInterval(time)
    time = null
    console.log('stop')
    // 返回数据给渲染进程
    event.reply('readReply', [])
}

